package cz.simecek.inspectionmanager.dto;

import cz.simecek.inspectionmanager.model.Machine;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.sql.Date;

public class InspectionDTO {

    private Long id;

    private Machine machine;

    @NotNull
    private Date doneAt;

    @NotBlank
    @Size(min = 2, max = 255)
    private String result;

    @NotBlank
    @Size(min = 2, max = 10000)
    private String description;

    @NotBlank
    @Size(min = 2, max = 255)
    private String bill;

    @NotBlank
    @Size(min = 2, max = 255)
    private String price;

    private Date createdAt;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Machine getMachine() {
        return machine;
    }

    public void setMachine(Machine machine) {
        this.machine = machine;
    }

    public Date getDoneAt() {
        return doneAt;
    }

    public void setDoneAt(Date doneAt) {
        this.doneAt = doneAt;
    }

    public String getResult() {
        return result;
    }

    public void setResult(String result) {
        this.result = result;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getBill() {
        return bill;
    }

    public void setBill(String bill) {
        this.bill = bill;
    }

    public String getPrice() {
        return price;
    }

    public void setPrice(String price) {
        this.price = price;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }
}

