package cz.simecek.inspectionmanager.dto;

import cz.simecek.inspectionmanager.model.Category;
import cz.simecek.inspectionmanager.model.Customer;
import cz.simecek.inspectionmanager.model.Inspection;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.sql.Date;
import java.util.Set;

public class MachineDTO {

    private Long id;

    private Customer customer;

    private Set<Inspection> inspections;

    private Set<Category> categories;

    private boolean canBeDeleted;

    @NotBlank
    @Size(max = 255)
    private String name;

    @NotBlank
    @Size(max = 255)
    private String code;

    @NotNull
    private Date nextInspectionAt;

    @Size(max = 255)
    private String note;

    private Boolean isBoughtLocally;

    @NotNull
    private Date boughtAt;

    private Date createdAt;

    private Boolean isWorking;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Customer getCustomer() {
        return customer;
    }

    public void setCustomer(Customer customer) {
        this.customer = customer;
    }

    public Set<Inspection> getInspections() {
        return inspections;
    }

    public void setInspections(Set<Inspection> inspections) {
        this.inspections = inspections;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Date getNextInspectionAt() {
        return nextInspectionAt;
    }

    public void setNextInspectionAt(Date nextInspectionAt) {
        this.nextInspectionAt = nextInspectionAt;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

    public Boolean getIsBoughtLocally() {
        return isBoughtLocally;
    }

    public void setIsBoughtLocally(Boolean boughtLocally) {
        isBoughtLocally = boughtLocally;
    }

    public Date getBoughtAt() {
        return boughtAt;
    }

    public void setBoughtAt(Date boughtAt) {
        this.boughtAt = boughtAt;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Boolean getIsWorking() {
        return isWorking;
    }

    public void setIsWorking(Boolean working) {
        isWorking = working;
    }


    public boolean getCanBeDeleted() {
        return canBeDeleted;
    }

    public void setCanBeDeleted(boolean canBeDeleted) {
        this.canBeDeleted = canBeDeleted;
    }

    public Boolean getBoughtLocally() {
        return isBoughtLocally;
    }

    public void setBoughtLocally(Boolean boughtLocally) {
        isBoughtLocally = boughtLocally;
    }

    public Boolean getWorking() {
        return isWorking;
    }

    public void setWorking(Boolean working) {
        isWorking = working;
    }

    public Set<Category> getCategories() {
        return categories;
    }

    public void setCategories(Set<Category> categories) {
        this.categories = categories;
    }

    public boolean isCanBeDeleted() {
        return canBeDeleted;
    }
}
