package cz.simecek.inspectionmanager.model;

import org.springframework.data.annotation.CreatedDate;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.sql.Date;
import java.util.Set;

@Entity
public class Inspection {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @ManyToOne
    @JoinColumn(nullable = false)
    private Machine machine;

    @OneToMany(mappedBy = "inspection")
    private Set<InspectionHistory> inspectionHistories;

    @Column
    private Date doneAt;

    @Size(max = 255)
    private String result;

    @Size(max = 10000)
    private String description;

    @Size(max = 255)
    private String bill;

    @Size(max = 255)
    private String price;

    @CreatedDate
    private Date createdAt;

    @Column
    private Boolean isDeleted;

    @ManyToOne
    @JoinColumn(nullable = false)
    private SystemUser createdBy;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Machine getMachine() {
        return machine;
    }

    public void setMachine(Machine machine) {
        this.machine = machine;
    }

    public Date getDoneAt() {
        return doneAt;
    }

    public void setDoneAt(Date doneAt) {
        this.doneAt = doneAt;
    }

    public String getResult() {
        return result;
    }

    public void setResult(String result) {
        this.result = result;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getBill() {
        return bill;
    }

    public void setBill(String bill) {
        this.bill = bill;
    }

    public String getPrice() {
        return price;
    }

    public void setPrice(String price) {
        this.price = price;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Set<InspectionHistory> getInspectionHistories() {
        return inspectionHistories;
    }

    public void setInspectionHistories(Set<InspectionHistory> inspectionHistories) {
        this.inspectionHistories = inspectionHistories;
    }

    public Boolean getDeleted() {
        return isDeleted;
    }

    public void setDeleted(Boolean deleted) {
        isDeleted = deleted;
    }

    public SystemUser getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(SystemUser createdBy) {
        this.createdBy = createdBy;
    }

    @Override
    public String toString() {
        return "Kontrola {" +
                " provedeno=" + doneAt +
                ", výsledek='" + result + '\'' +
                ", popis='" + description + '\'' +
                ", účet='" + bill + '\'' +
                ", cena='" + price + '\'' +
                ", vytvořen=" + createdAt +
                ", smazán=" + isDeleted +
                '}';
    }
}
