package cz.simecek.inspectionmanager.model;

import javax.persistence.*;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.HashSet;
import java.util.Set;

@Entity
public class SparePart {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @NotBlank
    @Size(max = 255)
    private String name;

    @NotBlank
    @Size(max = 255)
    @Column(unique = true)
    private String code;

    @Size(max = 255)
    private String price;

    @ManyToMany(fetch = FetchType.LAZY,
            cascade = {
                    CascadeType.PERSIST,
                    CascadeType.MERGE
            }, mappedBy = "spareParts")
    private Set<Machine> machines = new HashSet<>();

    @OneToMany(mappedBy = "sparePart")
    private Set<SparePartHistory> sparePartHistories;

    @Column
    private Boolean isDeleted;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getPrice() {
        return price;
    }

    public void setPrice(String price) {
        this.price = price;
    }

    public Set<Machine> getMachines() {
        return machines;
    }

    public void setMachines(Set<Machine> machines) {
        this.machines = machines;
    }

    public Set<SparePartHistory> getSparePartHistories() {
        return sparePartHistories;
    }

    public void setSparePartHistories(Set<SparePartHistory> sparePartHistories) {
        this.sparePartHistories = sparePartHistories;
    }

    public Boolean getDeleted() {
        return isDeleted;
    }

    public void setDeleted(Boolean deleted) {
        isDeleted = deleted;
    }

    @Override
    public String toString() {
        return "Náhradní díl {" +
                " jméno='" + name + '\'' +
                ", kód='" + code + '\'' +
                ", cena='" + price + '\'' +
                ", smazáno=" + isDeleted +
                '}';
    }
}
