package cz.simecek.inspectionmanager.model;

import javax.persistence.*;
import java.util.Set;

@Entity
public class SystemUser {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @Column(unique = true)
    private String userName;

    @Column
    private String password;

    @Column
    private Boolean isBlocked;

    @ManyToOne
    @JoinColumn(nullable = false)
    private Role role;

    @OneToMany(mappedBy = "createdBy")
    private Set<Machine> machines;

    @OneToMany(mappedBy = "createdBy")
    private Set<Category> categories;

    @OneToMany(mappedBy = "createdBy")
    private Set<Inspection> inspections;

    @OneToMany(mappedBy = "createdBy")
    private Set<MachineHistory> machineHistories;

    @OneToMany(mappedBy = "createdBy")
    private Set<Customer> customers;

    @OneToMany(mappedBy = "createdBy")
    private Set<CustomerHistory> customerHistories;

    @OneToMany(mappedBy = "createdBy")
    private Set<InspectionHistory> inspectionHistories;

    @OneToMany(mappedBy = "createdBy")
    private Set<SparePartHistory> sparePartHistories;

    @OneToMany(mappedBy = "createdBy")
    private Set<SystemUserHistory> systemUserHistoriesCreatedBy;

    @OneToMany(mappedBy = "systemUser")
    private Set<SystemUserHistory> systemUserHistories;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String name) {
        this.userName = name;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public Role getRole() {
        return role;
    }

    public void setRole(Role role) {
        this.role = role;
    }

    public Set<Machine> getMachines() {
        return machines;
    }

    public void setMachines(Set<Machine> machines) {
        this.machines = machines;
    }

    public Boolean getBlocked() {
        return isBlocked;
    }

    public void setBlocked(Boolean blocked) {
        isBlocked = blocked;
    }

    public Set<MachineHistory> getMachineHistories() {
        return machineHistories;
    }

    public void setMachineHistories(Set<MachineHistory> machineHistories) {
        this.machineHistories = machineHistories;
    }

    public Set<Inspection> getInspections() {
        return inspections;
    }

    public void setInspections(Set<Inspection> inspections) {
        this.inspections = inspections;
    }

    public Set<Customer> getCustomers() {
        return customers;
    }

    public void setCustomers(Set<Customer> customers) {
        this.customers = customers;
    }

    public Set<CustomerHistory> getCustomerHistories() {
        return customerHistories;
    }

    public void setCustomerHistories(Set<CustomerHistory> customerHistories) {
        this.customerHistories = customerHistories;
    }

    public Set<InspectionHistory> getInspectionHistories() {
        return inspectionHistories;
    }

    public void setInspectionHistories(Set<InspectionHistory> inspectionHistories) {
        this.inspectionHistories = inspectionHistories;
    }

    public Set<Category> getCategories() {
        return categories;
    }

    public void setCategories(Set<Category> categories) {
        this.categories = categories;
    }

    public Set<SparePartHistory> getSparePartHistories() {
        return sparePartHistories;
    }

    public void setSparePartHistories(Set<SparePartHistory> sparePartHistories) {
        this.sparePartHistories = sparePartHistories;
    }

    @Override
    public String toString() {
        return "Uživatel {" +
                ", jméno='" + userName + '\'' +
                ", blokován=" + isBlocked +
                ", role=" + this.role.getName() +
                '}';
    }
}
