package cz.simecek.inspectionmanager.repository;

import cz.simecek.inspectionmanager.model.Machine;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.sql.Date;
import java.util.List;
import java.util.Optional;

@Repository
public interface MachineRepository extends CrudRepository<Machine, Long> {

    List<Machine> findByIsDeletedAndCustomer_Id(Boolean isDeleted, Long id);

    @Query("SELECT m FROM Machine m WHERE m.nextInspectionAt <= :now AND m.isDeleted = false")
    List<Machine> findLateInspection(@Param("now") Date date);

    Iterable<Machine> findByIsDeleted(Boolean isDeleted);

    Optional<Machine> findByIdAndIsDeleted(Long id, Boolean isDeleted);

    Iterable<Machine> findByIsDeletedAndCategories_IdNot(Boolean isDeleted, Long id);

    Iterable<Machine> findByIsDeletedAndCategories_Id(Boolean isDeleted, Long id);
}
