package cz.simecek.inspectionmanager.repository;

import cz.simecek.inspectionmanager.model.Machine;
import cz.simecek.inspectionmanager.model.SparePart;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.sql.Date;
import java.util.List;
import java.util.Optional;

@Repository
public interface SparePartRepository extends CrudRepository<SparePart, Long> {

    Iterable<SparePart> findByIsDeletedAndMachines_Id(Boolean isDeleted, Long id);

    Iterable<SparePart> findByIsDeleted(Boolean isDeleted);

    Optional<SparePart> findByIdAndIsDeleted(Long id, Boolean isDeleted);

    Optional<SparePart> findByCode(String code);
}
