package cz.simecek.inspectionmanager.service.machine;

import cz.simecek.inspectionmanager.dto.CustomerDTO;
import cz.simecek.inspectionmanager.dto.MachineDTO;
import cz.simecek.inspectionmanager.model.Machine;
import cz.simecek.inspectionmanager.model.MachineHistory;

import java.util.List;

public interface MachineService {
    List<MachineDTO> getAll();

    void save(MachineDTO machineDTO, Long customerId);

    MachineDTO getById(Long machineId);

    void delete(Long machineId);

    void update(MachineDTO machineDTO, Long machineId);

    List<MachineDTO> getByCustomer(Long customerId);

    List<MachineDTO> findLateInspections();

    Machine getMachineById(Long id);

    void saveMachine(Machine machine);

    List<MachineHistory> getHistoryById(Long id);

    List<MachineDTO> getDeleted();

    void renew(Long id);

    List<MachineDTO> getAllMachinesExcludeByCategoryId(Long id);

    List<MachineDTO> getAllByCategory(Long id);
}
