package cz.simecek.inspectionmanager.service.role;

import cz.simecek.inspectionmanager.exception.InvalidUserRole;
import cz.simecek.inspectionmanager.model.Role;
import cz.simecek.inspectionmanager.repository.RoleRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class RoleServiceImpl implements RoleService {

    private final RoleRepository roleRepository;

    @Autowired
    public RoleServiceImpl(RoleRepository roleRepository) {
        this.roleRepository = roleRepository;
    }

    @Override
    public List<Role> getAll() {
        return roleRepository.findAll();
    }

    @Override
    public Role getById(Long id) {
        return roleRepository.findById(id).orElseThrow(InvalidUserRole::new);
    }
}
