package cz.simecek.inspectionmanager.service.user;

import cz.simecek.inspectionmanager.dto.PasswordDTO;
import cz.simecek.inspectionmanager.dto.RoleDTO;
import cz.simecek.inspectionmanager.dto.UserPasswordDTO;
import cz.simecek.inspectionmanager.model.SystemUser;
import cz.simecek.inspectionmanager.dto.UserDTO;
import cz.simecek.inspectionmanager.model.SystemUserHistory;

import java.util.List;

public interface UserService {
    void save(UserDTO userDTO);

    SystemUser findByUsername(String username);

    void delete(Long id);

    List<UserDTO> getAll();

    UserDTO findById(Long id);

    void changePassword(PasswordDTO passwordDTO);

    void changeRole(RoleDTO roleDTO);

    SystemUser getCurrentUser();

    List<SystemUser> getAllBlocked();

    void activate(Long id);

    List<SystemUserHistory> getHistoryById(Long id);

    List<SystemUser> getAllAllowed();

    void deactivate(Long id);

    void updatePasswordByUser(UserPasswordDTO userPasswordDTO);
}
